#include <TFile.h>
#include <TObjArray.h>
#include <TGraph.h>
#include <TObject.h>
#include <TCint.h>
#include <TColor.h>
#include <TGraphErrors.h>
#include <TMultiGraph.h>
#include <TMarker.h>
#include <TTree.h>
#include <TBranch.h>
#include <TFolder.h>
#include <TString.h>
#include <TH1.h>
#include <TLegend.h>
#include <THStack.h>
#include <TCanvas.h>
#include <iostream>
#include <cstdio>
#include <sstream>


using namespace std;


int main(){



Double_t PETotpmt1;
Double_t PETotpmt2;
Double_t PETotpmt3;
Double_t PETotb;


ostringstream title;
ostringstream titlegraph1;
ostringstream titlegraph2;
ostringstream titlegraph3;
ostringstream titlegraph4;


ostringstream endTitle;
ostringstream otherTitle;




 

title<<"mu0_1GeVRanPosRanDir";

otherTitle<<title.str().c_str()<<"TotPmts.root"<<ends;

cout<<"Processing "<<otherTitle.str().c_str()<<"...";
TFile *myfile =TFile::Open(otherTitle.str().c_str());

titlegraph1<<title.str()<<"pmt1";
titlegraph2<<title.str()<<"pmt2";
titlegraph3<<title.str()<<"pmt3";
titlegraph4<<title.str()<<"Tot";

TH1F *primo =(TH1F*)myfile->Get(titlegraph1.str().c_str());
primo->SetName("pmt1");
int nbins1 = primo->GetNbinsX();
int bincontent1 = 0;
int x1=0;
for (int i=0; i<nbins1; i++)
         {
               bincontent1 = primo -> GetBinContent(i+1);
               if (bincontent1 !=0)
               {
                      x1= primo -> GetBinCenter(i+1);                  
	        }
         }
primo->SetAxisRange(0,x1,"x");
primo->SetLineColor(2);

//TH1F *clone1 =(TH1F*)primo->Clone();
	 
TH1F *secondo =(TH1F*)myfile->Get(titlegraph2.str().c_str());
secondo->SetName("pmt2");
int nbins2 = secondo->GetNbinsX();
int bincontent2 = 0;
int x2=0;
for (int l=0; l<nbins2; l++)
         {
               bincontent2 = secondo -> GetBinContent(l+1);
               if (bincontent2 !=0)
               {
                      x2= secondo -> GetBinCenter(l+1);                  
	        }
         }
secondo->SetAxisRange(0,x2,"x");
secondo->SetLineColor(3);

//TH1F *clone2 =(TH1F*)secondo->Clone();

TH1F *terzo =(TH1F*)myfile->Get(titlegraph3.str().c_str());
terzo->SetName("pmt3");
int nbins3 = terzo->GetNbinsX();
int bincontent3 = 0;
int x3=0;
for (int m=0; m<nbins3; m++)
         {
               bincontent3 = terzo -> GetBinContent(m+1);
               if (bincontent3 !=0)
               {
                      x3= terzo -> GetBinCenter(m+1);                  
	        }
         }
terzo->SetAxisRange(0,x3,"x");
terzo->SetLineColor(4);

//TH1F *clone3 =(TH1F*)terzo->Clone();

TH1F *tot =(TH1F*)myfile->Get(titlegraph4.str().c_str());
tot->SetName("tot");
int nbins4 = tot->GetNbinsX();
int bincontent4 = 0;
int x4=0;
for (int n=0; n<nbins4; n++)
         {
               bincontent4 = tot -> GetBinContent(n+1);
               if (bincontent4 !=0)
               {
                      x4= tot -> GetBinCenter(n+1);                  
	        }
         }
tot->SetAxisRange(0,x4,"x");
tot->SetLineColor(6);

//TH1F *clone4 =(TH1F*)tot->Clone();

THStack *hs = new THStack("pmts","pmts");

hs->Add(primo);
hs->Add(secondo);   //i have tryed to solve the problem adding the cloned histos but with no results
hs->Add(terzo);
hs->Add(tot);

endTitle<<title.str()<<"Sov.root";

TFile *prova =new TFile(endTitle.str().c_str(),"recreate");
primo->Write();
secondo->Write();
terzo->Write();
tot->Write();
hs->Write();

cout<<"All Green!\n";

return 0;
}














